summaryrefslogtreecommitdiff
path: root/util
diff options
context:
space:
mode:
authorLoïc Blot <nerzhul@users.noreply.github.com>2017-03-25 19:12:18 +0100
committerGitHub <noreply@github.com>2017-03-25 19:12:18 +0100
commit22567d107fffe7a6833b96cc99d531e5303b47dd (patch)
tree8ca2a1a40965dfe362c16ec1d8fe4d1cfd43e1a3 /util
parent5a59ad230744a84a1474e8c3b97cf3d9080536d7 (diff)
downloadminetest-22567d107fffe7a6833b96cc99d531e5303b47dd.tar.gz
minetest-22567d107fffe7a6833b96cc99d531e5303b47dd.tar.bz2
minetest-22567d107fffe7a6833b96cc99d531e5303b47dd.zip
Add clang format & skip build if no source file modified (#5433)
* [BUILD] Add clang format + build skipping * Add clang-format tool to check codestyle. Warning: it check the whole modified file, not the diff part, it's why it's lazy. Please also look if rules are perfect, i take the Linux codestyle from LLVM site Fix issue #5415 * Skip building project if no file is modified * Fix a wrong brace to trigger LINT * Make lint step outside of unix build scope * Add AccessModifierOffset: -8 * Typo fix & needs compile fix * Fix header priorities
Diffstat (limited to 'util')
-rwxr-xr-xutil/travis/before_install.sh12
-rw-r--r--util/travis/common.sh3
-rwxr-xr-xutil/travis/script.sh36
3 files changed, 49 insertions, 2 deletions
diff --git a/util/travis/before_install.sh b/util/travis/before_install.sh
index ea85b3db6..a4328fa46 100755
--- a/util/travis/before_install.sh
+++ b/util/travis/before_install.sh
@@ -1,7 +1,15 @@
#!/bin/bash -e
echo "Preparing for $TRAVIS_COMMIT_RANGE"
-. util/travis/common.sh
+if [[ "$LINT" == "1" ]]; then
+ curl http://apt.llvm.org/llvm-snapshot.gpg.key | sudo apt-key add -
+ sudo add-apt-repository "deb http://apt.llvm.org/trusty/ llvm-toolchain-trusty-3.9 main"
+ sudo apt-get -yq update
+ sudo apt-get install clang-format-3.9
+ exit 0
+fi
+
+. util/travis/common.sh
needs_compile || exit 0
if [[ $TRAVIS_OS_NAME == "linux" ]]; then
@@ -11,6 +19,7 @@ fi
if [[ $PLATFORM == "Unix" ]]; then
if [[ $TRAVIS_OS_NAME == "linux" ]]; then
+ sudo apt-get update
sudo apt-get install libirrlicht-dev cmake libbz2-dev libpng12-dev \
libjpeg-dev libxxf86vm-dev libgl1-mesa-dev libsqlite3-dev \
libhiredis-dev libogg-dev libgmp-dev libvorbis-dev libopenal-dev \
@@ -21,6 +30,7 @@ if [[ $PLATFORM == "Unix" ]]; then
if [[ "$VALGRIND" == "1" ]]; then
sudo apt-get install valgrind
fi
+
else
brew update
brew install freetype gettext hiredis irrlicht jpeg leveldb libogg libvorbis luajit
diff --git a/util/travis/common.sh b/util/travis/common.sh
index 16c7db324..35ceec08d 100644
--- a/util/travis/common.sh
+++ b/util/travis/common.sh
@@ -1,8 +1,9 @@
#!/bin/bash -e
# Relative to git-repository root:
-TRIGGER_COMPILE_PATHS="src/|CMakeLists.txt|cmake/Modules/|util/travis/|util/buildbot/"
+TRIGGER_COMPILE_PATHS="src/.*\.(c|cpp|h)|CMakeLists.txt|cmake/Modules/|util/travis/|util/buildbot/"
needs_compile() {
git diff --name-only $TRAVIS_COMMIT_RANGE | egrep -q "^($TRIGGER_COMPILE_PATHS)"
}
+
diff --git a/util/travis/script.sh b/util/travis/script.sh
index 84ea578a5..557822e1f 100755
--- a/util/travis/script.sh
+++ b/util/travis/script.sh
@@ -3,21 +3,57 @@
needs_compile || exit 0
+function perform_lint() {
+ CLANG_FORMAT=clang-format-3.9
+ if [ "$TRAVIS_EVENT_TYPE" = "pull_request" ]; then
+ # Get list of every file modified in this pull request
+ files_to_lint="$(git diff --name-only --diff-filter=ACMRTUXB $TRAVIS_COMMIT_RANGE | grep '^src/[^.]*[.]\(cpp\|h\)$' | egrep -v '^src/(gmp|lua|jsoncpp)/' || true)"
+ else
+ # Check everything for branch pushes
+ files_to_lint="$(find src/ -name '*.cpp' -or -name '*.h' | egrep -v '^src/(gmp|lua|jsoncpp)/')"
+ fi
+
+ local fail=0
+ for f in ${files_to_lint}; do
+ d=$(diff -u "$f" <(${CLANG_FORMAT} "$f") || true)
+ if ! [ -z "$d" ]; then
+ printf "The file %s is not compliant with the coding style:\n%s\n" "$f" "$d"
+ # Disable build failure at this moment as we need to have a complete MT source whitelist to check
+ fail=0
+ fi
+ done
+
+ if [ "$fail" = 1 ]; then
+ exit 1
+ fi
+
+ exit 0
+}
+
+if [[ "$LINT" == "1" ]]; then
+ # Lint with exit CI
+ perform_lint
+fi
+
if [[ $PLATFORM == "Unix" ]]; then
mkdir -p travisbuild
cd travisbuild || exit 1
+
CMAKE_FLAGS=''
if [[ $COMPILER == "g++-6" ]]; then
export CC=gcc-6
export CXX=g++-6
fi
+
# Clang builds with FreeType fail on Travis
if [[ $CC == "clang" ]]; then
CMAKE_FLAGS+=' -DENABLE_FREETYPE=FALSE'
fi
+
if [[ $TRAVIS_OS_NAME == "osx" ]]; then
CMAKE_FLAGS+=' -DCUSTOM_GETTEXT_PATH=/usr/local/opt/gettext'
fi
+
cmake -DCMAKE_BUILD_TYPE=Debug \
-DRUN_IN_PLACE=TRUE \
-DENABLE_GETTEXT=TRUE \